Imports System.IO
Imports System.Data.SqlServerCe
Imports System.Text

Public Class frmMain

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        strStartUp = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)
        Compact()

        'TODO: This line of code loads data into the 'DsMedicalRecords.tblSurgery' table. You can move, or remove it, as needed.
        Me.TblSurgeryTableAdapter.Fill(Me.DsMedicalRecords.tblSurgery)
        'TODO: This line of code loads data into the 'DsMedicalRecords.tblPharmacy' table. You can move, or remove it, as needed.
        Me.TblPharmacyTableAdapter.Fill(Me.DsMedicalRecords.tblPharmacy)
        'TODO: This line of code loads data into the 'DsMedicalRecords.tblDoctor' table. You can move, or remove it, as needed.
        Me.TblDoctorTableAdapter.Fill(Me.DsMedicalRecords.tblDoctor)
        'TODO: This line of code loads data into the 'DsMedicalRecords.tblMedication' table. You can move, or remove it, as needed.
        Me.TblMedicationTableAdapter.Fill(Me.DsMedicalRecords.tblMedication)
        'TODO: This line of code loads data into the 'DsMedicalRecords.tblPatient' table. You can move, or remove it, as needed.
        Me.TblPatientTableAdapter.Fill(Me.DsMedicalRecords.tblPatient)

        If Screen.PrimaryScreen.Bounds.Height <> 480 Then
            UseableScreen = Screen.PrimaryScreen.Bounds.Height - 2 * (Screen.PrimaryScreen.Bounds.Height - Screen.PrimaryScreen.WorkingArea.Height)
        Else
            UseableScreen = 409
        End If


        ScreenWidth = Screen.PrimaryScreen.Bounds.Width

        colDataGrid.Add(dgPatient)
        colDataGrid.Add(dgMedication)
        colDataGrid.Add(dgDoctor)
        colDataGrid.Add(dgPharmacy)
        colDataGrid.Add(dgSurgery)

        colDataGridStyle.Add(dgPatientStyle)
        colDataGridStyle.Add(dgMedicationStyle)
        colDataGridStyle.Add(dgDoctorStyle)
        colDataGridStyle.Add(dgPharmacyStyle)
        colDataGridStyle.Add(dgSurgeryStyle)

        colTables.Add(DsMedicalRecords.tblPatient)
        colTables.Add(DsMedicalRecords.tblMedication)
        colTables.Add(DsMedicalRecords.tblDoctor)
        colTables.Add(DsMedicalRecords.tblPharmacy)
        colTables.Add(DsMedicalRecords.tblSurgery)

        colIcons.Add(pbxPatient)
        colIcons.Add(pbxPatient)
        colIcons.Add(pbxMedication)
        colIcons.Add(pbxDoctor)
        colIcons.Add(pbxPharmacy)
        colIcons.Add(pbxSurgery)

        icnSpacing = ScreenWidth / 41
        icnSize = 7 * icnSpacing

        For Each pbxIcon In colIcons
            pbxIcon.Width = icnSize
            pbxIcon.Height = icnSize
        Next

        For Each dgDataGrid In colDataGrid

        Next

        sipChange(sender, e)

    End Sub

    Private Sub sipChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InputPanel1.EnabledChanged

        PanelHeight = InputPanel1.Bounds.Height

        If (InputPanel1.Enabled) Then
            tcMain.Height = UseableScreen - PanelHeight
            pbxLogo.Visible = False
        Else
            tcMain.Height = UseableScreen
            pbxLogo.Visible = True
        End If

        DataGridHeight = tcMain.TabPages(0).Height

        For Each dgDataGrid In colDataGrid
            dgDataGrid.Height = DataGridHeight
        Next

        Dim CurrX As Integer
        For Each pbxIcon In colIcons
            CurrX = pbxIcon.Location.X
            pbxIcon.Location = New Point(CurrX, DataGridHeight - icnSize)
        Next

    End Sub

    Private Sub tcPageChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tcMain.SelectedIndexChanged

        Select Case (tcMain.SelectedIndex)
            Case 0
                Me.Text = "Welcome"
                mnuNew.Enabled = False
                mnuNew.Text = "Add Record"
            Case 1
                Me.Text = "Patient"
                mnuNew.Enabled = True
                mnuNew.Text = "New Patient"
            Case 2
                Me.Text = "Medication"
                mnuNew.Enabled = True
                mnuNew.Text = "New Medication"
            Case 3
                Me.Text = "Doctor"
                mnuNew.Enabled = True
                mnuNew.Text = "New Doctor"
            Case 4
                Me.Text = "Pharmacy"
                mnuNew.Enabled = True
                mnuNew.Text = "New Pharmacy"
            Case 5
                Me.Text = "Surgery"
                mnuNew.Enabled = True
                mnuNew.Text = "New Surgery"
        End Select

    End Sub

    Private Sub mnuNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNew.Click
        Select Case (tcMain.SelectedIndex)
            Case 0

            Case 1
                'Patient
                TblPatientBindingSource.AllowNew = True
                TblPatientBindingSource.AddNew()

                ' Pass the binding source to the form.
                Dim EditViewDialog As New frmAddPatient(TblPatientBindingSource)
                If EditViewDialog.ShowDialog() <> DialogResult.OK Then
                    TblPatientBindingSource.CancelEdit()
                    dgPatient.Refresh()
                Else
                    TblPatientBindingSource.EndEdit()
                    Me.TblPatientTableAdapter.Update(Me.DsMedicalRecords)
                End If
            Case 2
                'Medication
                TblMedicationBindingSource.AllowNew = True
                TblMedicationBindingSource.AddNew()

                ' Pass the binding source to the form.
                Dim EditViewDialog As New frmAddMedication(TblMedicationBindingSource)
                If EditViewDialog.ShowDialog() <> DialogResult.OK Then
                    TblMedicationBindingSource.CancelEdit()
                    dgMedication.Refresh()
                Else
                    TblMedicationBindingSource.EndEdit()
                    Me.TblMedicationTableAdapter.Update(Me.DsMedicalRecords)
                End If
            Case 3
                'Doctor
                TblDoctorBindingSource.AllowNew = True
                TblDoctorBindingSource.AddNew()

                ' Pass the binding source to the form.
                Dim EditViewDialog As New frmAddDoctor(TblDoctorBindingSource)
                If EditViewDialog.ShowDialog() <> DialogResult.OK Then
                    TblDoctorBindingSource.CancelEdit()
                    dgDoctor.Refresh()
                Else
                    TblDoctorBindingSource.EndEdit()
                    Me.TblDoctorTableAdapter.Update(Me.DsMedicalRecords)
                End If
            Case 4
                'Pharmacy
                TblPharmacyBindingSource.AllowNew = True
                TblPharmacyBindingSource.AddNew()

                ' Pass the binding source to the form.
                Dim EditViewDialog As New frmAddPharmacy(TblPharmacyBindingSource)
                If EditViewDialog.ShowDialog() <> DialogResult.OK Then
                    TblPharmacyBindingSource.CancelEdit()
                    dgPharmacy.Refresh()
                Else
                    TblPharmacyBindingSource.EndEdit()
                    Me.TblPharmacyTableAdapter.Update(Me.DsMedicalRecords)
                End If
            Case 5
                'Surgery
                TblSurgeryBindingSource.AllowNew = True
                TblSurgeryBindingSource.AddNew()

                ' Pass the binding source to the form.
                Dim EditViewDialog As New frmAddSurgery(TblSurgeryBindingSource)
                If EditViewDialog.ShowDialog() <> DialogResult.OK Then
                    TblSurgeryBindingSource.CancelEdit()
                    dgSurgery.Refresh()
                Else
                    TblSurgeryBindingSource.EndEdit()
                    Me.TblSurgeryTableAdapter.Update(Me.DsMedicalRecords)
                End If
        End Select

    End Sub

    Private Sub dgPatient_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgPatient.Click
        dgPatient.Select(dgPatient.CurrentRowIndex)
        Dim SummaryDialog As New frmSummaryPatient(TblPatientBindingSource)
        SummaryDialog.ShowDialog()
    End Sub
    Private Sub dgSurgery_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgSurgery.Click
        dgSurgery.Select(dgSurgery.CurrentRowIndex)
        Dim SummaryDialog As New frmSummarySurgery(TblSurgeryBindingSource)
        SummaryDialog.ShowDialog()
    End Sub
    Private Sub dgDoctor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgDoctor.Click
        dgDoctor.Select(dgDoctor.CurrentRowIndex)
        Dim SummaryDialog As New frmSummaryDoctor(TblDoctorBindingSource)
        SummaryDialog.ShowDialog()
    End Sub
    Private Sub dgPharmacy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgPharmacy.Click
        dgPharmacy.Select(dgPharmacy.CurrentRowIndex)
        Dim SummaryDialog As New frmSummaryPharmacy(TblPharmacyBindingSource)
        SummaryDialog.ShowDialog()
    End Sub
    Private Sub dgMedication_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgMedication.Click
        dgMedication.Select(dgMedication.CurrentRowIndex)
        Dim SummaryDialog As New frmSummaryMedication(TblMedicationBindingSource)
        SummaryDialog.ShowDialog()
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        'Compact()
        Application.Exit()
    End Sub

    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        Dim strMessage As String

        strMessage = "Medical Manager"
        strMessage = strMessage + vbCrLf + "Version " + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString

        MessageBox.Show(strMessage)

    End Sub

    Private Sub pbxPatient_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxPatient.Click

        tcMain.SelectedIndex = 1

    End Sub

    Private Sub pbxMedication_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxMedication.Click

        tcMain.SelectedIndex = 2

    End Sub

    Private Sub pbxDoctor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxDoctor.Click

        tcMain.SelectedIndex = 3

    End Sub

    Private Sub pbxPharmacy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxPharmacy.Click

        tcMain.SelectedIndex = 4

    End Sub

    Private Sub pbxSurgery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxSurgery.Click

        tcMain.SelectedIndex = 5

    End Sub

    Private Sub mnuHome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHome.Click

        tcMain.SelectedIndex = 0

    End Sub

    Private Sub mnuAddAppointment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAddAppointment.Click

        frmAddAppointment.ShowDialog()

    End Sub
    Private Sub mnuAddMedication_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAddMedication.Click

        frmAddPatientMedication.ShowDialog()

    End Sub

    Private Sub Compact()
        Dim src As String

        src = strStartUp + "\MedicalRecords.sdf"
        Dim dest As String = strStartUp + "\Comp_Temp.sdf"

        Dim engine As New SqlCeEngine("Data Source = " + src)
        Try
            engine.Compact(("Data Source = " + dest))
            engine.Dispose()

            File.Delete(src)
            File.Move(dest, src)

        Catch err As SqlCeException
            'Use your own error handling routine.
            ShowErrors(err)
        Finally
            'Dispose of the SqlCeEngine object.
            engine.Dispose()
        End Try

    End Sub

    Public Shared Sub ShowErrors(ByVal e As SqlCeException)
        Dim errorCollection As SqlCeErrorCollection = e.Errors

        Dim bld As New StringBuilder
        Dim inner As Exception = e.InnerException

        If Not inner Is Nothing Then
            MessageBox.Show(("Inner Exception: " & inner.ToString()))
        End If

        Dim err As SqlCeError

        ' Enumerate each error to a message box.
        For Each err In errorCollection
            bld.Append((ControlChars.Cr & " Error Code: " & err.HResult.ToString("X")))
            bld.Append((ControlChars.Cr & " Message   : " & err.Message))
            bld.Append((ControlChars.Cr & " Minor Err.: " & err.NativeError))
            bld.Append((ControlChars.Cr & " Source    : " & err.Source))

            ' Retrieve the error parameter numbers for each error.
            Dim numPar As Integer
            For Each numPar In err.NumericErrorParameters
                If 0 <> numPar Then
                    bld.Append((ControlChars.Cr & " Num. Par. : " & numPar))
                End If
            Next numPar

            ' Retrieve the error parameters for each error.
            Dim errPar As String
            For Each errPar In err.ErrorParameters
                If [String].Empty <> errPar Then
                    bld.Append((ControlChars.Cr & " Err. Par. : " & errPar))
                End If
            Next errPar

            MessageBox.Show(bld.ToString())
            bld.Remove(0, bld.Length)
        Next err
    End Sub
End Class