Imports System.Data.SqlServerCe
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms

Public Class frmSummaryPatient
    Dim CurrentBindingSource As BindingSource

    Public Sub New(ByVal bsource As BindingSource)
        CurrentBindingSource = bsource
        ' This call is required by the Windows Forms Designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
        ' Bind the label that shows the product name.

        lblPatientFirstName.DataBindings.Add("Text", CurrentBindingSource, "PatientFirstName")
        lblPatientSurname.DataBindings.Add("Text", CurrentBindingSource, "PatientSurname")
        Try
            dtpPatientDoB.DataBindings.Add("Value", CurrentBindingSource, "PatientDoB")
        Catch

        End Try
        lblPatientAddress1.DataBindings.Add("Text", CurrentBindingSource, "PatientAddress1")
        lblPatientAddress2.DataBindings.Add("Text", CurrentBindingSource, "PatientAddress2")
        lblPatientTown.DataBindings.Add("Text", CurrentBindingSource, "PatientTown")
        lblPatientCounty.DataBindings.Add("Text", CurrentBindingSource, "PatientCounty")
        lblPatientPostCode.DataBindings.Add("Text", CurrentBindingSource, "PatientPostCode")
        lblPatientMobileNo.DataBindings.Add("Text", CurrentBindingSource, "PatientMobileNo")
        If dtpPatientDoB.Value.Date <> Today.Date Then
            lblPatientDoB.Text = Format(dtpPatientDoB.Value, "dd MMM yyyy")
        Else
            lblPatientDoB.Text = ""
        End If

        lblPatientID.DataBindings.Add("Text", CurrentBindingSource, "PatientID")
        cntPatient = lblPatientID.Text
        strPatient = lblPatientFirstName.Text & " " & lblPatientSurname.Text

    End Sub

    Private Sub mnuClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuClose.Click
        Me.Close()
    End Sub

    Private Sub mnuEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEdit.Click

        ' Pass the binding source to the form.
        Dim EditViewDialog As New frmAddPatient(TblPatientBindingSource)
        If EditViewDialog.ShowDialog() <> DialogResult.OK Then
            TblPatientBindingSource.CancelEdit()
        Else
            TblPatientBindingSource.EndEdit()
            Me.TblPatientTableAdapter.Update(Me.DsMedicalRecords)
        End If

    End Sub

    Private Sub frmSummaryPatient_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        
    End Sub

    Private Sub frmSummaryPatient_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadPatientDoctor()
        LoadPatientMedication()

    End Sub
    Sub LoadPatientMedication()

        dgPatientMedication.Visible = False
        dgPatientMedication.RowHeadersVisible = False

        Dim dtPatientMedication As New DataTable
        Dim connString As String
        Dim connection As New SqlCeConnection
        Dim command As New SqlCeCommand
        Dim adapter As New SqlCeDataAdapter
        Dim sql As String

        connString = "Persist Security Info=False; Data Source=" & strStartUp & "\MedicalRecords.sdf"
        connection = New SqlCeConnection(connString)
        connection.Open()

        'PatientMedication
        Dim dgpmts As DataGridTableStyle = New DataGridTableStyle()
        Dim dgpmtbc As New DataGridTextBoxColumn()
        sql = "SELECT tblMedication.MedicationTitle, tblMedication.MedicationStrength FROM tblPatient INNER JOIN (tblMedication INNER JOIN tblPatientMedication ON tblMedication.MedicationID=tblPatientMedication.MedicationID) ON tblPatient.PatientID=tblPatientMedication.PatientID WHERE tblPatientMedication.PatientID = " & cntPatient

        command = New SqlCeCommand(sql, connection)
        adapter.SelectCommand = command
        adapter.Fill(dtPatientMedication)

        dgPatientMedication.Width = 3 * ScreenWidth / 4
        dgPatientMedication.Height = UseableScreen / 2
        dgPatientMedication.Top = UseableScreen / 2
        dgPatientMedication.Left = 0

        dgpmts.MappingName = ""
        dgPatientMedication.TableStyles.Add(dgpmts)

        dgpmtbc.MappingName = "MedicationTitle"
        dgpmtbc.HeaderText = "Medication Name"
        dgpmtbc.Width = dgPatientMedication.Width * 0.6
        dgpmts.GridColumnStyles.Add(dgpmtbc)

        dgpmtbc = New DataGridTextBoxColumn()
        dgpmtbc.MappingName = "MedicationStrength"
        dgpmtbc.HeaderText = "Strength"
        dgpmtbc.Width = dgPatientMedication.Width * 0.3
        dgpmts.GridColumnStyles.Add(dgpmtbc)

        dgPatientMedication.DataSource = dtPatientMedication

        pbxMedication.Width = ScreenWidth / 5
        pbxMedication.Left = ScreenWidth * 4 / 5
        If UseableScreen <> 409 Then
            pbxMedication.Top = UseableScreen - 40
        Else
            pbxMedication.Top = UseableScreen - 60
        End If

        adapter.Dispose()
        command.Dispose()
        connection.Close()

    End Sub
    Sub LoadPatientDoctor()
        dgPatientDoctor.Visible = False
        dgPatientDoctor.RowHeadersVisible = False

        Dim dtPatientDoctor As New DataTable

        Dim connString As String
        Dim connection As New SqlCeConnection
        Dim command As New SqlCeCommand
        Dim adapter As New SqlCeDataAdapter
        Dim sql As String

        connString = "Persist Security Info=False; Data Source=" & strStartUp & "\MedicalRecords.sdf"
        connection = New SqlCeConnection(connString)
        connection.Open()

        'PatientDoctor
        Dim dgpdts As DataGridTableStyle = New DataGridTableStyle()
        Dim dgpdtbc As New DataGridTextBoxColumn()

        sql = "SELECT tblDoctor.DoctorName, tblDoctorPatient.AppointmentDate, tblDoctorPatient.AppointmentTime FROM tblDoctor INNER JOIN tblDoctorPatient ON tblDoctor.DoctorID = tblDoctorPatient.DoctorID WHERE tblDoctorPatient.PatientID = " & cntPatient

        connection = New SqlCeConnection(connString)
        connection.Open()
        command = New SqlCeCommand(sql, connection)
        adapter.SelectCommand = command
        adapter.Fill(dtPatientDoctor)

        dgPatientDoctor.Width = 3 * ScreenWidth / 4
        dgPatientDoctor.Height = UseableScreen / 2

        dgPatientDoctor.Top = UseableScreen / 2
        dgPatientDoctor.Left = 0

        dgpdts.MappingName = ""
        dgPatientDoctor.TableStyles.Add(dgpdts)

        dgpdtbc = New DataGridTextBoxColumn()
        dgpdtbc.MappingName = "DoctorName"
        dgpdtbc.HeaderText = "Doctor"
        dgpdtbc.Width = dgPatientDoctor.Width * 0.6
        dgpdts.GridColumnStyles.Add(dgpdtbc)

        dgpdtbc = New DataGridTextBoxColumn()
        dgpdtbc.MappingName = "AppointmentDate"
        dgpdtbc.HeaderText = "Date"
        dgpdtbc.Format = "dd MMM yy"
        dgpdtbc.Width = dgPatientDoctor.Width * 0.3
        dgpdts.GridColumnStyles.Add(dgpdtbc)

        dgPatientDoctor.DataSource = dtPatientDoctor

        adapter.Dispose()
        command.Dispose()
        connection.Close()

        pbxDoctor.Width = ScreenWidth / 5
        pbxDoctor.Left = ScreenWidth * 4 / 5
        If UseableScreen <> 409 Then
            pbxDoctor.Top = UseableScreen - 80
        Else
            pbxDoctor.Top = UseableScreen - 100
        End If


    End Sub

    Private Sub pbxDataGrid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxMedication.Click

        If dgPatientMedication.Visible = True Then
            dgPatientMedication.Visible = False
        Else
            dgPatientMedication.Visible = True
            dgPatientDoctor.Visible = False
        End If

    End Sub
    Private Sub sipChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InputPanel1.EnabledChanged

        PanelHeight = InputPanel1.Bounds.Height

        If (InputPanel1.Enabled) Then
            dgPatientMedication.Visible = False
            pbxMedication.Visible = False
        Else
            pbxMedication.Visible = True
        End If

    End Sub

    Private Sub dgPatientMedication_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgPatientMedication.Click

        frmPatientMedicationSummary.ShowDialog()
        LoadPatientMedication()

    End Sub


    Private Sub pbxDoctor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxDoctor.Click

        If dgPatientDoctor.Visible = True Then
            dgPatientDoctor.Visible = False
        Else
            dgPatientDoctor.Visible = True
            dgPatientMedication.Visible = False
        End If

    End Sub

    Private Sub dgPatientDoctor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgPatientDoctor.Click

        frmPatientDoctorSummary.ShowDialog()
        LoadPatientDoctor()

    End Sub


End Class